<template>
  <b-form-group
      :description="field.description"
      :label="field.label"
      :label-for="field.id">
    <b-form-select
        :id="field.id"
        :disabled="loading"
        :value="window"
        @change="setWindow"
        :options="field.options"/>
  </b-form-group>
</template>

<script>
import {mapState, mapActions, mapGetters} from 'vuex'
import {WINDOW_DAY, WINDOW_WEEK, WINDOW_MONTH, WINDOW_YEAR, WINDOW_ALL} from '../service/imgur-service'

export default {
  name: 'WindowFilter',
  computed: {
    ...mapState({
      window: state => state.gallery.requestOptions.window
    }),
    ...mapGetters({
      loading: 'gallery/loading'
    })
  },
  data() {
    return {
      field: {
        id: 'window-select',
        label: 'Window by',
        description: 'Choose one of these window types',
        options: [
          {value: WINDOW_DAY, text: 'day'},
          {value: WINDOW_WEEK, text: 'week'},
          {value: WINDOW_MONTH, text: 'month'},
          {value: WINDOW_YEAR, text: 'year'},
          {value: WINDOW_ALL, text: 'all'},
        ],
      }
    }
  },
  methods: {
    ...mapActions({
      setWindow: 'gallery/setWindow'
    }),
  }
}
</script>

<style scoped>

</style>